Index: trunk/src/VBox/Devices/Network/DrvNAT.cpp
===================================================================
--- trunk/src/VBox/Devices/Network/DrvNAT.cpp	(revision 14390)
+++ trunk/src/VBox/Devices/Network/DrvNAT.cpp	(revision 14391)
@@ -39,5 +39,5 @@
 #include "Builtins.h"
 
-#ifdef VBOX_WITH_SIMPLEFIED_SLIRP_SYNC
+#ifdef VBOX_WITH_SIMPLIFIED_SLIRP_SYNC
 # ifndef RT_OS_WINDOWS
 #  include <unistd.h>
@@ -65,5 +65,5 @@
     /** Pointer to the driver instance. */
     PPDMDRVINS              pDrvIns;
-#ifndef VBOX_WITH_SIMPLEFIED_SLIRP_SYNC
+#ifndef VBOX_WITH_SIMPLIFIED_SLIRP_SYNC
     /** Slirp critical section. */
     RTCRITSECT              CritSect;
@@ -77,5 +77,5 @@
     /** Boot file name to provide in the DHCP server response. */
     char                    *pszBootFile;
-#ifdef VBOX_WITH_SIMPLEFIED_SLIRP_SYNC
+#ifdef VBOX_WITH_SIMPLIFIED_SLIRP_SYNC
     /* polling thread */
     PPDMTHREAD              pThread;
@@ -125,5 +125,5 @@
     Log2(("drvNATSend: pvBuf=%p cb=%#x\n%.*Rhxd\n", pvBuf, cb, cb, pvBuf));
 
-#ifdef VBOX_WITH_SIMPLEFIED_SLIRP_SYNC
+#ifdef VBOX_WITH_SIMPLIFIED_SLIRP_SYNC
 
     PRTREQ pReq = NULL;
@@ -159,5 +159,5 @@
     RTReqFree(pReq);
 
-#else /* !VBOX_WITH_SIMPLEFIED_SLIRP_SYNC */
+#else /* !VBOX_WITH_SIMPLIFIED_SLIRP_SYNC */
 
     int rc = RTCritSectEnter(&pThis->CritSect);
@@ -168,5 +168,5 @@
     RTCritSectLeave(&pThis->CritSect);
 
-#endif /* !VBOX_WITH_SIMPLEFIED_SLIRP_SYNC */
+#endif /* !VBOX_WITH_SIMPLIFIED_SLIRP_SYNC */
 
     LogFlow(("drvNATSend: end\n"));
@@ -230,5 +230,5 @@
     LogFlow(("drvNATNotifyLinkChanged: enmLinkState=%d\n", enmLinkState));
 
-#ifdef VBOX_WITH_SIMPLEFIED_SLIRP_SYNC
+#ifdef VBOX_WITH_SIMPLIFIED_SLIRP_SYNC
 
     PRTREQ pReq = NULL;
@@ -262,5 +262,5 @@
     RTReqFree(pReq);
 
-#else /* !VBOX_WITH_SIMPLEFIED_SLIRP_SYNC */
+#else /* !VBOX_WITH_SIMPLIFIED_SLIRP_SYNC */
 
     int rc = RTCritSectEnter(&pThis->CritSect);
@@ -269,9 +269,9 @@
     RTCritSectLeave(&pThis->CritSect);
 
-#endif /* VBOX_WITH_SIMPLEFIED_SLIRP_SYNC */
-}
-
-
-#ifndef VBOX_WITH_SIMPLEFIED_SLIRP_SYNC
+#endif /* VBOX_WITH_SIMPLIFIED_SLIRP_SYNC */
+}
+
+
+#ifndef VBOX_WITH_SIMPLIFIED_SLIRP_SYNC
 
 /**
@@ -302,5 +302,5 @@
 }
 
-#else /* VBOX_WITH_SIMPLEFIED_SLIRP_SYNC */
+#else /* VBOX_WITH_SIMPLIFIED_SLIRP_SYNC */
 
 static DECLCALLBACK(int) drvNATAsyncIoThread(PPDMDRVINS pDrvIns, PPDMTHREAD pThread)
@@ -409,5 +409,5 @@
 }
 
-#endif /* VBOX_WITH_SIMPLEFIED_SLIRP_SYNC */
+#endif /* VBOX_WITH_SIMPLIFIED_SLIRP_SYNC */
 
 
@@ -423,5 +423,5 @@
     Assert(pThis);
 
-#ifndef VBOX_WITH_SIMPLEFIED_SLIRP_SYNC
+#ifndef VBOX_WITH_SIMPLIFIED_SLIRP_SYNC
     /** Happens during termination */
     if (!RTCritSectIsOwner(&pThis->CritSect))
@@ -446,5 +446,5 @@
     Assert(pThis);
 
-#ifndef VBOX_WITH_SIMPLEFIED_SLIRP_SYNC
+#ifndef VBOX_WITH_SIMPLIFIED_SLIRP_SYNC
     /** Happens during termination */
     if (!RTCritSectIsOwner(&pThis->CritSect))
@@ -496,5 +496,5 @@
     LogFlow(("drvNATDestruct:\n"));
 
-#ifndef VBOX_WITH_SIMPLEFIED_SLIRP_SYNC
+#ifndef VBOX_WITH_SIMPLIFIED_SLIRP_SYNC
     int rc = RTCritSectEnter(&pThis->CritSect);
     AssertReleaseRC(rc);
@@ -502,5 +502,5 @@
     slirp_term(pThis->pNATState);
     pThis->pNATState = NULL;
-#ifndef VBOX_WITH_SIMPLEFIED_SLIRP_SYNC
+#ifndef VBOX_WITH_SIMPLIFIED_SLIRP_SYNC
     RTCritSectLeave(&pThis->CritSect);
     RTCritSectDelete(&pThis->CritSect);
@@ -711,5 +711,5 @@
      * The slirp lock..
      */
-#ifndef VBOX_WITH_SIMPLEFIED_SLIRP_SYNC
+#ifndef VBOX_WITH_SIMPLIFIED_SLIRP_SYNC
     rc = RTCritSectInit(&pThis->CritSect);
     if (RT_FAILURE(rc))
@@ -734,5 +734,5 @@
                                        NULL, NULL, NULL, NULL, NULL, drvNATLoadDone);
             AssertRC(rc2);
-#ifndef VBOX_WITH_SIMPLEFIED_SLIRP_SYNC
+#ifndef VBOX_WITH_SIMPLIFIED_SLIRP_SYNC
             pDrvIns->pDrvHlp->pfnPDMPollerRegister(pDrvIns, drvNATPoller);
 #else
@@ -779,5 +779,5 @@
     }
 
-#ifndef VBOX_WITH_SIMPLEFIED_SLIRP_SYNC
+#ifndef VBOX_WITH_SIMPLIFIED_SLIRP_SYNC
     RTCritSectDelete(&pThis->CritSect);
 #endif
Index: trunk/src/VBox/Devices/Network/slirp/libslirp.h
===================================================================
--- trunk/src/VBox/Devices/Network/slirp/libslirp.h	(revision 14390)
+++ trunk/src/VBox/Devices/Network/slirp/libslirp.h	(revision 14391)
@@ -50,5 +50,5 @@
                    int guest_port);
 
-#if defined(VBOX_WITH_SIMPLEFIED_SLIRP_SYNC) && defined(RT_OS_WINDOWS) 
+#if defined(VBOX_WITH_SIMPLIFIED_SLIRP_SYNC) && defined(RT_OS_WINDOWS) 
 /**
  * This event is for
Index: trunk/src/VBox/Devices/Network/slirp/slirp.c
===================================================================
--- trunk/src/VBox/Devices/Network/slirp/slirp.c	(revision 14390)
+++ trunk/src/VBox/Devices/Network/slirp/slirp.c	(revision 14391)
@@ -226,5 +226,5 @@
         WSAStartup(MAKEWORD(2,0), &Data);
     }
-#if defined(VBOX_WITH_SIMPLEFIED_SLIRP_SYNC) && defined(RT_OS_WINDOWS)
+#if defined(VBOX_WITH_SIMPLIFIED_SLIRP_SYNC) && defined(RT_OS_WINDOWS)
 	pData->phEvents[VBOX_SOCKET_EVENT_INDEX] = CreateEvent(NULL, FALSE, FALSE, NULL);
 #endif
@@ -339,5 +339,5 @@
          "\n"));
 #endif
-#if defined(VBOX_WITH_SIMPLEFIED_SLIRP_SYNC) && defined(RT_OS_WINDOWS)
+#if defined(VBOX_WITH_SIMPLIFIED_SLIRP_SYNC) && defined(RT_OS_WINDOWS)
     free(pData->phEvents);
 #endif
@@ -382,5 +382,5 @@
     int nfds;
     int tmp_time;
-#if defined(VBOX_WITH_SIMPLEFIED_SLIRP_SYNC) && defined(RT_OS_WINDOWS)
+#if defined(VBOX_WITH_SIMPLIFIED_SLIRP_SYNC) && defined(RT_OS_WINDOWS)
     int rc;
     int error;
@@ -444,5 +444,5 @@
 			if (so->so_state & SS_FACCEPTCONN) {
                                 STAM_REL_COUNTER_INC(&pData->StatTCPHot);
-#if !defined(VBOX_WITH_SIMPLEFIED_SLIRP_SYNC) || !defined(RT_OS_WINDOWS)
+#if !defined(VBOX_WITH_SIMPLIFIED_SLIRP_SYNC) || !defined(RT_OS_WINDOWS)
                                 FD_SET(so->s, readfds);
 				UPD_NFDS(so->s);
@@ -464,5 +464,5 @@
 			if (so->so_state & SS_ISFCONNECTING) {
                                 STAM_REL_COUNTER_INC(&pData->StatTCPHot);
-#if !defined(VBOX_WITH_SIMPLEFIED_SLIRP_SYNC) || !defined(RT_OS_WINDOWS)
+#if !defined(VBOX_WITH_SIMPLIFIED_SLIRP_SYNC) || !defined(RT_OS_WINDOWS)
 				FD_SET(so->s, writefds);
 				UPD_NFDS(so->s);
@@ -481,5 +481,5 @@
 			if (CONN_CANFSEND(so) && so->so_rcv.sb_cc) {
                                 STAM_REL_COUNTER_INC(&pData->StatTCPHot);
-#if !defined(VBOX_WITH_SIMPLEFIED_SLIRP_SYNC) || !defined(RT_OS_WINDOWS)
+#if !defined(VBOX_WITH_SIMPLIFIED_SLIRP_SYNC) || !defined(RT_OS_WINDOWS)
 				FD_SET(so->s, writefds);
 				UPD_NFDS(so->s);
@@ -498,5 +498,5 @@
 			if (CONN_CANFRCV(so) && (so->so_snd.sb_cc < (so->so_snd.sb_datalen/2))) {
                                 STAM_REL_COUNTER_INC(&pData->StatTCPHot);
-#if !defined(VBOX_WITH_SIMPLEFIED_SLIRP_SYNC) || !defined(RT_OS_WINDOWS)
+#if !defined(VBOX_WITH_SIMPLIFIED_SLIRP_SYNC) || !defined(RT_OS_WINDOWS)
 				FD_SET(so->s, readfds);
 				FD_SET(so->s, xfds);
@@ -509,5 +509,5 @@
 #endif
 			}
-#if defined(VBOX_WITH_SIMPLEFIED_SLIRP_SYNC) && defined(RT_OS_WINDOWS)
+#if defined(VBOX_WITH_SIMPLIFIED_SLIRP_SYNC) && defined(RT_OS_WINDOWS)
 			rc = WSAEventSelect(so->s, NULL, 0);
                         if (rc == SOCKET_ERROR)
@@ -550,5 +550,5 @@
 			if ((so->so_state & SS_ISFCONNECTED) && so->so_queued <= 4) {
                                 STAM_REL_COUNTER_INC(&pData->StatUDPHot);
-#if !defined(VBOX_WITH_SIMPLEFIED_SLIRP_SYNC) || !defined(RT_OS_WINDOWS)
+#if !defined(VBOX_WITH_SIMPLIFIED_SLIRP_SYNC) || !defined(RT_OS_WINDOWS)
 				FD_SET(so->s, readfds);
 				UPD_NFDS(so->s);
@@ -560,5 +560,5 @@
 #endif
 			}
-#if defined(VBOX_WITH_SIMPLEFIED_SLIRP_SYNC) && defined(RT_OS_WINDOWS)
+#if defined(VBOX_WITH_SIMPLIFIED_SLIRP_SYNC) && defined(RT_OS_WINDOWS)
                         else
                         {
@@ -604,5 +604,5 @@
 		}
 	}
-#if !defined(VBOX_WITH_SIMPLEFIED_SLIRP_SYNC) || !defined(RT_OS_WINDOWS)
+#if !defined(VBOX_WITH_SIMPLIFIED_SLIRP_SYNC) || !defined(RT_OS_WINDOWS)
         *pnfds = nfds;
 #else
@@ -617,5 +617,5 @@
     struct socket *so, *so_next;
     int ret;
-#if defined(VBOX_WITH_SIMPLEFIED_SLIRP_SYNC) && defined(RT_OS_WINDOWS)
+#if defined(VBOX_WITH_SIMPLIFIED_SLIRP_SYNC) && defined(RT_OS_WINDOWS)
 	WSANETWORKEVENTS NetworkEvents;
 	int rc;
@@ -646,5 +646,5 @@
 		}
 	}
-#if defined(VBOX_WITH_SIMPLEFIED_SLIRP_SYNC) && defined(RT_OS_WINDOWS)
+#if defined(VBOX_WITH_SIMPLIFIED_SLIRP_SYNC) && defined(RT_OS_WINDOWS)
 	if (timer_update) return;
 #endif
@@ -666,5 +666,5 @@
 			if (so->so_state & SS_NOFDREF || so->s == -1)
 			   continue;
-#if defined(VBOX_WITH_SIMPLEFIED_SLIRP_SYNC) && defined(RT_OS_WINDOWS)
+#if defined(VBOX_WITH_SIMPLIFIED_SLIRP_SYNC) && defined(RT_OS_WINDOWS)
 			rc = WSAEnumNetworkEvents(so->s, VBOX_SOCKET_EVENT, &NetworkEvents);
                         if (rc == SOCKET_ERROR)
@@ -681,5 +681,5 @@
 			 * test for readfds below if this succeeds
 			 */
-#if !defined(VBOX_WITH_SIMPLEFIED_SLIRP_SYNC) || !defined(RT_OS_WINDOWS)
+#if !defined(VBOX_WITH_SIMPLIFIED_SLIRP_SYNC) || !defined(RT_OS_WINDOWS)
 			if (FD_ISSET(so->s, xfds))
 #else
@@ -691,5 +691,5 @@
 			 * Check sockets for reading
 			 */
-#if !defined(VBOX_WITH_SIMPLEFIED_SLIRP_SYNC) || !defined(RT_OS_WINDOWS)
+#if !defined(VBOX_WITH_SIMPLIFIED_SLIRP_SYNC) || !defined(RT_OS_WINDOWS)
 			else if (FD_ISSET(so->s, readfds)) {
 #else
@@ -713,5 +713,5 @@
 			 * Check sockets for writing
 			 */
-#if !defined(VBOX_WITH_SIMPLEFIED_SLIRP_SYNC) || !defined(RT_OS_WINDOWS)
+#if !defined(VBOX_WITH_SIMPLIFIED_SLIRP_SYNC) || !defined(RT_OS_WINDOWS)
 			if (FD_ISSET(so->s, writefds)) {
 #else
@@ -807,5 +807,5 @@
 			so_next = so->so_next;
 
-#if defined(VBOX_WITH_SIMPLEFIED_SLIRP_SYNC) && defined(RT_OS_WINDOWS)
+#if defined(VBOX_WITH_SIMPLIFIED_SLIRP_SYNC) && defined(RT_OS_WINDOWS)
 			rc = WSAEnumNetworkEvents(so->s, VBOX_SOCKET_EVENT, &NetworkEvents);
                         if (rc == SOCKET_ERROR)
@@ -816,5 +816,5 @@
                         }
 #endif
-#if !defined(VBOX_WITH_SIMPLEFIED_SLIRP_SYNC) || !defined(RT_OS_WINDOWS)
+#if !defined(VBOX_WITH_SIMPLIFIED_SLIRP_SYNC) || !defined(RT_OS_WINDOWS)
 			if (so->s != -1 && FD_ISSET(so->s, readfds)) {
 #else
@@ -1002,5 +1002,5 @@
 }
 
-#if defined(VBOX_WITH_SIMPLEFIED_SLIRP_SYNC) && defined(RT_OS_WINDOWS)
+#if defined(VBOX_WITH_SIMPLIFIED_SLIRP_SYNC) && defined(RT_OS_WINDOWS)
 HANDLE *slirp_get_events(PNATState pData)
 {
Index: trunk/src/VBox/Devices/Network/slirp/slirp_state.h
===================================================================
--- trunk/src/VBox/Devices/Network/slirp/slirp_state.h	(revision 14390)
+++ trunk/src/VBox/Devices/Network/slirp/slirp_state.h	(revision 14391)
@@ -130,5 +130,5 @@
     struct socket udb;
     struct socket *udp_last_so;
-#if defined(VBOX_WITH_SIMPLEFIED_SLIRP_SYNC) && defined(RT_OS_WINDOWS)
+#if defined(VBOX_WITH_SIMPLIFIED_SLIRP_SYNC) && defined(RT_OS_WINDOWS)
 # define VBOX_SOCKET_EVENT (pData->phEvents[VBOX_SOCKET_EVENT_INDEX])
     HANDLE phEvents[VBOX_EVENT_COUNT];