Index: trunk/src/VBox/Frontends/VirtualBox4/include/QILabelSeparator.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox4/include/QILabelSeparator.h	(revision 14397)
+++ trunk/src/VBox/Frontends/VirtualBox4/include/QILabelSeparator.h	(revision 14398)
@@ -44,5 +44,5 @@
     void clear();
     void setText (const QString &aText);
-
+    QString text() const;
 
 protected:
Index: trunk/src/VBox/Frontends/VirtualBox4/src/QILabelSeparator.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox4/src/QILabelSeparator.cpp	(revision 14397)
+++ trunk/src/VBox/Frontends/VirtualBox4/src/QILabelSeparator.cpp	(revision 14398)
@@ -58,4 +58,9 @@
 }
 
+QString QILabelSeparator::text() const
+{
+    return mLabel->text();
+}
+
 void QILabelSeparator::init()
 {
Index: trunk/src/VBox/Frontends/VirtualBox4/src/VBoxSettingsDialog.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox4/src/VBoxSettingsDialog.cpp	(revision 14397)
+++ trunk/src/VBox/Frontends/VirtualBox4/src/VBoxSettingsDialog.cpp	(revision 14398)
@@ -131,5 +131,5 @@
 
     mErrorHint = tr ("Invalid settings detected");
-    mWarnHint = tr ("Important warnings detected");
+    mWarnHint = tr ("Non-optimal settings detected");
     if (!mValid)
         mIconLabel->setWarningText (mErrorHint);
@@ -169,5 +169,5 @@
 {
     mWarnString = aWarning.isEmpty() ? QString::null :
-                  QString ("<font color=#ff6c00>%1</font>").arg (aWarning);
+                  QString ("<font color=#ff5400>%1</font>").arg (aWarning);
 
     /* Not touching QILabel until dialog is polished otherwise
Index: trunk/src/VBox/Frontends/VirtualBox4/src/VBoxSettingsDialogSpecific.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox4/src/VBoxSettingsDialogSpecific.cpp	(revision 14397)
+++ trunk/src/VBox/Frontends/VirtualBox4/src/VBoxSettingsDialogSpecific.cpp	(revision 14398)
@@ -367,5 +367,5 @@
     valid = page->revalidate (text, pageTitle);
     text = text.isEmpty() ? QString::null :
-           tr ("%1 on the <b>%2</b> page.").arg (text, pageTitle);
+           tr ("On the <b>%1</b> page, %2").arg (pageTitle, text);
     aWval->setLastWarning (text);
     valid ? setWarning (text) : setError (text);
Index: trunk/src/VBox/Frontends/VirtualBox4/src/VBoxVMSettingsGeneral.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox4/src/VBoxVMSettingsGeneral.cpp	(revision 14397)
+++ trunk/src/VBox/Frontends/VirtualBox4/src/VBoxVMSettingsGeneral.cpp	(revision 14398)
@@ -386,24 +386,28 @@
     if (mSlRam->value() + mSlVideo->value() > 0.75 * fullSize)
     {
-        aWarning = tr ("You have assigned more than 75% of your computer's memory (%1) to "
-                       "the virtual machine. Not enough memory is left for your host "
-                       "operating system. Please select a smaller amount. Error found")
-                       .arg (vboxGlobal().formatSize (fullSize * _1M));
+        aWarning = tr (
+            "you have assigned more than <b>75%</b> of your computer's memory "
+            "(<b>%1</b>) to the virtual machine. Not enough memory is left "
+            "for your host operating system. Please select a smaller amount.")
+            .arg (vboxGlobal().formatSize (fullSize * _1M));
         return false;
     } else
     if (mSlRam->value() + mSlVideo->value() > 0.5 * fullSize)
     {
-        aWarning = tr ("You have assigned more than 50% of your computer's memory (%1) to "
-                       "the virtual machine. Not enough memory might be left for your host "
-                       "operating system. Continue at your own risk. Problem found")
-                       .arg (vboxGlobal().formatSize (fullSize * _1M));
+        aWarning = tr (
+            "you have assigned more than <b>50%</b> of your computer's memory "
+            "(<b>%1</b>) to the virtual machine. Not enough memory might be "
+            "left for your host operating system. Continue at your own risk.")
+            .arg (vboxGlobal().formatSize (fullSize * _1M));
         return true;
     } else
-    if ((quint64)mSlVideo->value() * _1M < needBytes)
-    {
-        aWarning = tr ("You have assigned less than %1 for video memory. This is the minimum "
-                       "requirement for the guest to be able to switch to fullscreen or "
-                       "seamless mode. Problem found")
-                       .arg (vboxGlobal().formatSize (needBytes));
+    if ((quint64) mSlVideo->value() * _1M < needBytes)
+    {
+        aWarning = tr (
+            "you have assigned less than <b>%1</b> for video memory which is "
+            "the minimum amount required to switch the virtual machine to "
+            "fullscreen or seamless mode.")
+            .arg (vboxGlobal().formatSize (needBytes),
+            VBoxGlobal::removeAccelMark (mGbVideo->text()));
         return true;
     }
Index: trunk/src/VBox/Frontends/VirtualBox4/ui/VBoxVMSettingsGeneral.ui
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox4/ui/VBoxVMSettingsGeneral.ui	(revision 14397)
+++ trunk/src/VBox/Frontends/VirtualBox4/ui/VBoxVMSettingsGeneral.ui	(revision 14398)
@@ -728,5 +728,5 @@
            </property>
            <property name="whatsThis" >
-            <string>When checked, the VirtualBox allows guests to make use of the 3D graphics support available on the host.</string>
+            <string>When checked, the virtual machine will get access to the 3D graphics capabilities available on the host.</string>
            </property>
            <property name="text" >