Index: /trunk/src/VBox/Installer/linux/Makefile.kmk
===================================================================
--- /trunk/src/VBox/Installer/linux/Makefile.kmk	(revision 14445)
+++ /trunk/src/VBox/Installer/linux/Makefile.kmk	(revision 14446)
@@ -52,5 +52,4 @@
 		routines.sh \
 		vboxdrv.sh \
-		vboxnet.sh \
 		VirtualBox.tar.bz2 \
 		LICENSE) \
@@ -58,5 +57,4 @@
 	$(addprefix $(VBOX_LNX_INST_OUT_DIR)/,\
 		vboxdrv.sh \
-		vboxnet.sh \
 		install.sh)
 
@@ -69,12 +67,5 @@
 linux-bin_SOURCES = \
         VBoxSysInfo.sh \
-	VBox.sh=>VBox.sh \
-	$(PATH_linux-bin)/VBoxAddIF.sh
-linux-bin_CLEAN = \
-	$(PATH_linux-bin)/VBoxAddIF.sh
-
-$$(PATH_linux-bin)/VBoxAddIF.sh: $(PATH_SUB_CURRENT)/VBoxAddIF.sh $(VBOX_VERSION_STAMP) | $$(dir $$@)
-	$(call MSG_GENERATE,,$@,$<)
-	$(QUIET)$(SED) -e "s;_VERSION_;$(VBOX_VERSION_STRING);g" --output $@ $<
+	VBox.sh=>VBox.sh
 
 INSTALLS += linux-misc
@@ -152,5 +143,4 @@
 	VBox.sh \
 	VBox.png \
-	VBoxAddIF.sh \
 	src
 
@@ -234,5 +224,4 @@
 		$(VBOX_PATH_LNX_INST_SRC)/deffiles \
 		$(if $(VBOX_OSE),,$(VBOX_BRAND_LICENSE_TXT)) \
-		$(VBOX_LNX_INST_OUT_DIR)/vboxnet.sh \
 		$(VBOX_LNX_INST_OUT_DIR)/vboxdrv.sh \
 		$(VBOX_LNX_INST_OUT_DIR)/install.sh \
@@ -246,5 +235,4 @@
 	$(QUIET)$(INSTALL) -m 0755 $(VBOX_PATH_LNX_INST_SRC)/deffiles             $(VBOX_LNX_INST_STAGE_DIR)/
 	$(QUIET)$(if $(VBOX_OSE),,$(INSTALL) -m 0644 $(VBOX_BRAND_LICENSE_TXT)    $(VBOX_LNX_INST_STAGE_DIR)/LICENSE)
-	$(QUIET)$(INSTALL) -m 0755 $(VBOX_LNX_INST_OUT_DIR)/vboxnet.sh            $(VBOX_LNX_INST_STAGE_DIR)/
 	$(QUIET)$(INSTALL) -m 0755 $(VBOX_LNX_INST_OUT_DIR)/vboxdrv.sh            $(VBOX_LNX_INST_STAGE_DIR)/
 	$(QUIET)$(INSTALL) -m 0755 $(VBOX_LNX_INST_OUT_DIR)/install.sh            $(VBOX_LNX_INST_STAGE_DIR)/
@@ -260,7 +248,4 @@
 		--output $@ \
 		$<
-
-$(VBOX_LNX_INST_OUT_DIR)/vboxnet.sh: $(VBOX_PATH_LNX_INST_SRC)/vboxnet.sh.in | $$(dir $$@)
-	$(QUIET)$(SED_EXT) -e "s|%NOLSB%|yes|g" --output $@ $<
 
 $(VBOX_LNX_INST_OUT_DIR)/install.sh: $(VBOX_PATH_LNX_INST_SRC)/install.sh | $$(dir $$@)
Index: unk/src/VBox/Installer/linux/VBoxAddIF.sh
===================================================================
--- /trunk/src/VBox/Installer/linux/VBoxAddIF.sh	(revision 14445)
+++ 	(revision )
@@ -1,251 +1,0 @@
-#!/bin/sh
-#
-# Sun xVM VirtualBox
-# Permanent host interface creation script for Linux systems.
-
-#
-# Copyright (C) 2006-2007 Sun Microsystems, Inc.
-#
-# This file is part of VirtualBox Open Source Edition (OSE), as
-# available from http://www.virtualbox.org. This file is free software;
-# you can redistribute it and/or modify it under the terms of the GNU
-# General Public License (GPL) as published by the Free Software
-# Foundation, in version 2 as it comes in the "COPYING" file of the
-# VirtualBox OSE distribution. VirtualBox OSE is distributed in the
-# hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
-#
-# Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
-# Clara, CA 95054 USA or visit http://www.sun.com if you need
-# additional information or have any questions.
-#
-
-# This script creates a new permanent host interface on a Linux system.  In
-# fact, it does two things: it checks to see if the interface is present in
-# the list of permanent interfaces (/etc/vbox/interfaces) and checks to see
-# whether it can be created using VBoxTunctl.
-
-appname=`basename $0`
-interface=$1
-user=$2
-if [ "$user" = "-g" ]; then
-  shift;
-  group=$2
-  user=+$group
-fi
-bridge=$3
-
-appadd="VBoxAddIF"
-appdel="VBoxDeleteIF"
-
-iffile=/etc/vbox/interfaces
-varfile=/var/run/VirtualBox/vboxnet
-
-echo "VirtualBox host networking interface creation utility, version _VERSION_"
-echo "(C) 2005-2007 Sun Microsystems, Inc."
-echo "All rights reserved."
-
-# Print out the correct usage instructions for the utility
-usage() {
-  if [ "$appname" = "$appadd" ]
-  then
-    echo 1>&2 ""
-    echo 1>&2 "Usage: $appname <interface name>"
-    echo 1>&2 "                [<user name>| -g <group name>] [<bridge name>]"
-    echo 1>&2 "Create and register the permanent interface <interface name> for use by user"
-    echo 1>&2 "<user name> (or group <group name> for linux kernels which support this)"
-    echo 1>&2 "on the host system.  Optionally attach the interface to the network"
-    echo 1>&2 "bridge <bridge name>.  <interface name> should take the form vbox<0-99>."
-  elif [ "$appname" = "$appdel" ]
-  then
-    echo 1>&2 ""
-    echo 1>&2 "Usage: $appname <interface name>"
-    echo 1>&2 "Delete the permanent interface <interface name> from the host system."
-  else
-    echo 1>&2 ""
-    echo 1>&2 "Your VirtualBox setup appears to be incorrect.  This utility should be called"
-    echo 1>&2 "$appadd or $appdel."
-  fi
-}
-
-# Check which name we were called under, and exit if it was not recognised.
-if [ ! "$appname" = "$appadd" -a ! "$appname" = "$appdel" ]
-then
-  usage
-  exit 1
-fi
-
-# Check that we have the right number of command line arguments
-if [ "$appname" = "$appadd" ]
-then
-  if [ -z "$1" -o -z "$2" -o ! -z "$4" ]
-  then
-    usage
-    exit 1
-  fi
-elif [ "$appname" = "$appdel" ]
-then
-  if [ -z "$1" -o ! -z "$2" ]
-  then
-    usage
-    exit 1
-  fi
-fi
-
-# Make sure that we can create files in the configuration directory
-if [ ! -r /etc/vbox -o ! -w /etc/vbox -o ! -x /etc/vbox ]
-then
-  echo 1>&2 ""
-  echo 1>&2 "This utility must be able to access the folder /etc/vbox/.  Please"
-  echo 1>&2 "make sure that you have enough permissions to do this."
-  exit 1
-fi
-
-# Make sure that the configuration file is accessible and that the interface
-# is not already registered.
-if [ -f "$iffile" ]
-then
-  # Make sure that the configuration file is read and writable
-  if [ ! -r "$iffile" -o ! -w "$iffile" ]
-  then
-    echo 1>&2 ""
-    echo 1>&2 "This utility must be able to read from and write to the file"
-    echo 1>&2 "$iffile.  Please make sure that you have enough permissions to"
-    echo 1>&2 "do this."
-    exit 1
-  fi
-fi
-
-# Parse the configuration file and create a new, updated one.
-oldbridge=""
-foundif=""
-tempfile="$iffile.tmp"
-rm -f "$tempfile"
-if [ -f "$iffile" ]
-then
-  while read line
-  do
-    set ""$line
-    # If the line is a comment then ignore it
-    if (expr match "$1" "#" > /dev/null || test -z "$1")
-    then
-      echo ""$line >> "$tempfile"
-    else
-      # Check that the line is correctly formed (an interface name plus one
-      # or two non-comment entries, possibly followed by a comment).
-      if ((expr match "$2" "#" > /dev/null) ||
-          (! test -z "$4" && ! expr match "$4" "#" > /dev/null))
-      then
-        echo 1>&2 ""
-        echo 1>&2 "Removing badly formed line $line in $iffile."
-      # If the interface to be created is already registered in the file, then
-      # remove it and remember the fact
-      elif [ "$1" = "$interface" ]
-      then
-        # Remember which bridge the interface was attached to, if any, and
-        # do not write the line to the new configuration file.  Remember that
-        # we have found the interface in the file.
-        foundif=1
-        oldbridge="$3"
-      else
-        echo ""$line >> "$tempfile"
-      fi
-    fi # The line was not a comment
-  done < "$iffile"
-else
-  # Create the file $iffile and add some explanations as comments
-  echo "# This file is for registering VirtualBox permanent host networking interfaces" > "$tempfile"
-  echo "# and optionally adding them to network bridges on the host." >> "$tempfile"
-  echo "# Each line should be of the format <interface name> <user name> [<bridge>]." >> "$tempfile"
-  echo "" >> "$tempfile"
-fi
-mv -f "$tempfile" "$iffile"
-
-# Add the new interface line to the file if so requested
-if [ "$appname" = "$appadd" ]
-then
-  echo "$interface" "$user" "$bridge" >> "$iffile"
-  echo ""
-  if [ -n "$group" ]; then
-      echo "Creating the permanent host networking interface \"$interface\" for group $group."
-  else
-      echo "Creating the permanent host networking interface \"$interface\" for user $user."
-  fi
-fi
-
-# Remove the old interface (if it exists) from any bridge it was a part of and
-# take the interface down
-if [ ! -z "$oldbridge" ]
-then
-  brctl delif "$oldbridge" "$interface" > /dev/null 2>&1
-fi
-ifconfig "$interface" down > /dev/null 2>&1
-
-# Delete the old interface if it exists
-if ! VBoxTunctl -d "$interface" > /dev/null 2>&1
-then
-  echo 1>&2 ""
-  echo 1>&2 "Failed to take down the old interface in order to replace it with the new one."
-  echo 1>&2 "The interface may still be in use, or you may not currently have sufficient"
-  echo 1>&2 "permissions to do this.  You can replace the interface manually using the"
-  echo 1>&2 "VBoxTunctl command, or alternatively, the new interface will be created"
-  echo 1>&2 "automatically next time you restart the host system."
-  exit 1
-else
-  # Create the new interface and bring it up if we are adding it
-  if [ "$appname" = "$appadd" ]
-  then
-    if [ -n "$group" ]; then
-      if ! VBoxTunctl -t "$interface" -g "$group" > /dev/null 2>&1
-      then
-        echo 1>&2 ""
-        echo 1>&2 "Failed to create the interface \"$interface\" for group $group.  Please check"
-        echo 1>&2 "that you currently have sufficient permissions to do this."
-        exit 1
-      fi
-    else
-      if ! VBoxTunctl -t "$interface" -u "$user" > /dev/null 2>&1
-      then
-        echo 1>&2 ""
-        echo 1>&2 "Failed to create the interface \"$interface\" for user $user.  Please check"
-        echo 1>&2 "that you currently have sufficient permissions to do this."
-        exit 1
-      fi
-    fi
-    # On SUSE Linux Enterprise Server, the tunctl command does not take
-    # effect at once, so we loop until it does.
-    i=1
-    while [ $i -le 10 ]
-    do
-      ifconfig "$interface" up > /dev/null 2>&1
-      if ifconfig | grep "$interface" up > /dev/null 2>&1
-      then
-        i=11
-      else
-        i=`expr $i + 1`
-        sleep .1
-      fi
-    done
-    if [ ! -z "$bridge" ]
-    then
-      # And add it to a bridge if this was requested
-      if ! brctl addif "$bridge" "$interface" > /dev/null 2>&1
-      then
-        echo 1>&2 ""
-        echo 1>&2 "Failed to add the interface \"$interface\" to the bridge \"$bridge\"."
-        echo 1>&2 "Make sure that the bridge exists and that you currently have sufficient"
-        echo 1>&2 "permissions to do this."
-        echo $interface $user >> $varfile 2>/dev/null
-        exit 1
-      fi
-    fi
-    # We may end up with duplicate entries here, but this does no great harm.
-    echo $interface $user $bridge >> $varfile 2>/dev/null
-  fi # $appname = $appadd
-fi # VBoxTunctl -d succeeded
-
-if [ "$appname" = "$appdel" -a -z "$foundif" ]
-then
-  echo 1>&2 ""
-  echo 1>&2 "Warning: the utility could not find the registered interface \"$interface\"."
-  exit 1
-fi
Index: unk/src/VBox/Installer/linux/vboxnet.sh.in
===================================================================
--- /trunk/src/VBox/Installer/linux/vboxnet.sh.in	(revision 14445)
+++ 	(revision )
@@ -1,361 +1,0 @@
-#! /bin/sh
-# Sun xVM VirtualBox
-# Linux static host networking interface initialization
-#
-
-#
-# Copyright (C) 2007 Sun Microsystems, Inc.
-#
-# This file is part of VirtualBox Open Source Edition (OSE), as
-# available from http://www.virtualbox.org. This file is free software;
-# you can redistribute it and/or modify it under the terms of the GNU
-# General Public License (GPL) as published by the Free Software
-# Foundation, in version 2 as it comes in the "COPYING" file of the
-# VirtualBox OSE distribution. VirtualBox OSE is distributed in the
-# hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
-#
-
-# chkconfig: 35 30 60
-# description: VirtualBox permanent host networking setup
-#
-### BEGIN INIT INFO
-# Provides:       vboxnet
-# Required-Start: $network
-# Required-Stop:
-# Default-Start:  2 3 4 5
-# Default-Stop:   0 1 6
-# Description:    VirtualBox permanent host networking setup
-### END INIT INFO
-
-PATH=/sbin:/bin:/usr/sbin:/usr/bin:$PATH
-CONFIG="/etc/vbox/interfaces"
-VARDIR="/var/run/VirtualBox"
-VARFILE="/var/run/VirtualBox/vboxnet"
-TAPDEV="/dev/net/tun"
-NOLSB=%NOLSB%
-
-[ -f /lib/lsb/init-functions ] || NOLSB=yes
-
-if [ -n "$NOLSB" ]; then
-    if [ -f /etc/redhat-release ]; then
-        system=redhat
-    elif [ -f /etc/SuSE-release ]; then
-        system=suse
-    elif [ -f /etc/gentoo-release ]; then
-        system=gentoo
-    fi
-fi
-
-if [ -z "$NOLSB" ]; then
-    . /lib/lsb/init-functions
-    fail_msg() {
-        echo ""
-        log_failure_msg "$1"
-    }
-    succ_msg() {
-        log_success_msg " done."
-    }
-    begin_msg() {
-        log_daemon_msg "$@"
-    }
-else
-    if [ "$system" = "redhat" ]; then
-        . /etc/init.d/functions
-        fail_msg() {
-            echo_failure
-            echo
-            echo "  ($1)"
-        }
-        succ_msg() {
-            echo_success
-            echo
-        }
-    elif [ "$system" = "suse" ]; then
-        . /etc/rc.status
-        fail_msg() {
-            rc_failed 1
-            rc_status -v
-            echo "  ($1)"
-        }
-        succ_msg() {
-            rc_reset
-            rc_status -v
-        }
-    elif [ "$system" = "gentoo" ]; then
-        . /sbin/functions.sh
-        fail_msg() {
-            eerror "$1"
-        }
-        succ_msg() {
-            eend "$?"
-        }
-        begin_msg() {
-            ebegin "$1"
-        }
-        if [ "`which $0`" = "/sbin/rc" ]; then
-            shift
-        fi
-    else
-        fail_msg() {
-            echo " ...failed!"
-            echo "  ($1)"
-        }
-        succ_msg() {
-            echo " ...done."
-        }
-    fi
-    if [ "$system" != "gentoo" ]; then
-        begin_msg() {
-            [ -z "${1:-}" ] && return 1
-            if [ -z "${2:-}" ]; then
-                echo -n "$1"
-            else
-                echo -n "$1: $2"
-            fi
-        }
-    fi
-fi
-
-failure()
-{
-    fail_msg "$1"
-    # never return with exit code != 0
-    exit 0
-}
-
-running()
-{
-    test -f "$VARFILE"
-}
-
-# Create all permanent TAP devices registered on the system, add them to a
-# bridge if required and keep a record of proceedings in the file
-# /var/run/VirtualBox/vboxnet.  If this file already exists, assume that the
-# script has already been started and do nothing.
-start_network()
-{
-    begin_msg "Starting VirtualBox host networking"
-    # Set /dev/net/tun to belong to the group vboxusers if it exists and does
-    # yet belong to a group.
-    if ls -g "$TAPDEV" 2>/dev/null | grep root > /dev/null; then
-      chgrp vboxusers "$TAPDEV"
-      chmod 0660 "$TAPDEV"
-    fi
-    # If the service is already running, return successfully.
-    if [ -f "$VARFILE" ]; then
-      succ_msg
-      return 0
-    fi
-    # Fail if we can't create our runtime record file
-    if [ ! -d "$VARDIR" ]; then
-      if ! mkdir "$VARDIR" 2> /dev/null; then
-        failure "Cannot create $VARDIR"
-      fi
-    fi
-    if ! touch "$VARFILE" 2> /dev/null; then
-      failure "Cannot create $VARFILE"
-    fi
-    # If there is no configuration file, report success
-    if [ ! -f "$CONFIG" ]; then
-      succ_msg
-      return 0
-    fi
-    # Fail if we can't read our configuration
-    if [ ! -r "$CONFIG" ]; then
-      failure "Cannot read $CONFIG"
-    fi
-    # Fail if we don't have tunctl
-    if ! VBoxTunctl -h 2>&1 | grep VBoxTunctl > /dev/null; then
-      failure "VBoxTunctl not found"
-    fi
-    # Fail if we don't have the kernel tun device
-    # Make sure that the tun module is loaded (Ubuntu 7.10 needs this)
-    modprobe tun > /dev/null 2>&1
-    if ! cat /proc/misc 2>/dev/null | grep tun > /dev/null; then
-      failure "Linux tun/tap subsystem not available"
-    fi
-    succ_msg
-    # Read the configuration file entries line by line and create the
-    # interfaces
-    while read line; do
-      set ""$line
-      # If the line is a comment then ignore it
-      if ((! expr match "$1" "#" > /dev/null) && (! test -z "$1")); then
-        # Check that the line is correctly formed (an interface name plus one
-        # or two non-comment entries, possibly followed by a comment).
-        if ((! expr match "$2" "#" > /dev/null) &&
-            (test -z "$4" || expr match "$4" "#" > /dev/null)); then
-          # Name our parameters, to make this script slightly less unreadable
-          interface=$1
-          user=$2
-          bridge=$3
-          # As the very first thing, try delete the interface. Might already
-          # exist with different configuration. Ignore errors.
-          VBoxTunctl -d $interface > /dev/null 2>&1
-          case $user in
-            +*)
-                group=`echo $user | cut -c2-`
-                cmd="VBoxTunctl -t $interface -g $group"
-                ;;
-            *)
-                cmd="VBoxTunctl -t $interface -u $user"
-                ;;
-          esac
-          # Try to create the interface
-          if $cmd > /dev/null 2>&1; then
-            # On SUSE Linux Enterprise Server, the interface does not
-            # appear immediately, so we loop trying to bring it up.
-            i=1
-            while [ $i -le 10 ]; do
-              ifconfig "$interface" up 2> /dev/null
-              if ifconfig | grep "$interface" > /dev/null; then
-                # Add the interface to a bridge if one was specified
-                if [ -n "$bridge" ]; then
-                  if brctl addif "$bridge" "$interface" 2> /dev/null; then
-                    echo "$interface $user $bridge" >> "$VARFILE"
-                  else
-                    echo "$interface $user" >> "$VARFILE"
-                    echo "Warning - failed to add interface $interface to the bridge $bridge"
-                  fi
-                else
-                  echo "$interface $user" >> "$VARFILE"
-                fi
-                i=20
-              else
-                i=`expr $i + 1`
-                sleep .1
-              fi
-            done
-            if [ $i -ne 20 ]; then
-              echo "Warning - failed to bring up the interface $interface"
-            fi
-          else
-            echo "Warning - failed to create the interface $interface for the user $user"
-          fi
-        else
-          echo "Warning - invalid line in $CONFIG:"
-          echo "  $line"
-        fi
-      fi
-    done < "$CONFIG"
-    return 0
-}
-
-# Shut down VirtualBox host networking and remove all permanent TAP
-# interfaces.  This action will fail if some interfaces could not be removed.
-stop_network()
-{
-    begin_msg "Shutting down VirtualBox host networking"
-    # If there is no runtime record file, assume that the service is not
-    # running.
-    if [ ! -f "$VARFILE" ]; then
-      succ_msg
-      return 0
-    fi
-    # Fail if we can't read our runtime record file or write to the
-    # folder it is located in
-    if [ ! -r "$VARFILE" -o ! -w "$VARDIR" ]; then
-      failure "Failed to read $VARFILE or to write $VARDIR"
-    fi
-    # Fail if we don't have tunctl
-    if ! VBoxTunctl -h 2>&1 | grep VBoxTunctl > /dev/null; then
-      failure "VBoxTunctl not found"
-    fi
-    # Read the runtime record file entries line by line and delete the
-    # interfaces.  The format of the runtime record file is not checked for
-    # errors.
-    while read line; do
-      set ""$line
-      # Remove the interface from a bridge if it is part of one
-      if [ -n "$3" ]; then
-        brctl delif "$3" "$1" 2> /dev/null
-      fi
-      # Remove the interface.  Roll back everything and fail if this is not
-      # possible
-      if (! ifconfig "$1" down 2> /dev/null ||
-          ! VBoxTunctl -d "$1" > /dev/null 2>&1); then
-        while read line; do
-          set ""$line
-          VBoxTunctl -t "$1" -u "$2" > /dev/null 2>&1
-          ifconfig "$1" up 2> /dev/null
-          if [ -n "$3" ]; then
-            brctl addif "$3" "$1"
-          fi
-        done < "$VARFILE"
-      fi
-    done < "$VARFILE"
-    rm -f "$VARFILE" 2> /dev/null
-    succ_msg
-    return 0
-}
-
-# Shut down VirtualBox host networking and remove all permanent TAP
-# interfaces.  This action will succeed even if not all interfaces could be
-# removed.  It is only intended for exceptional circumstances such as
-# uninstalling VirtualBox.
-force_stop_network()
-{
-    begin_msg "Shutting down VirtualBox host networking"
-    # If there is no runtime record file, assume that the service is not
-    # running.
-    if [ ! -f "$VARFILE" ]; then
-      succ_msg
-      return 0
-    fi
-    # Fail if we can't read our runtime record file or write to the
-    # folder it is located in
-    if [ ! -r "$VARFILE" -o ! -w "$VARDIR" ]; then
-      failure "Failed to read $VARFILE or to write $VARDIR"
-    fi
-    # Fail if we don't have tunctl
-    if ! VBoxTunctl -h 2>&1 | grep VBoxTunctl > /dev/null; then
-      failure "VBoxTunctl not found"
-    fi
-    # Read the runtime record file entries line by line and delete the
-    # interfaces.  The format of the runtime record file is not checked for
-    # errors.
-    while read line; do
-      set ""$line
-      # Remove the interface from a bridge if it is part of one
-      if [ -n "$3" ]; then
-        brctl delif "$3" "$1" 2> /dev/null
-      fi
-      # Remove the interface.
-      ifconfig "$1" down 2> /dev/null
-      VBoxTunctl -d "$1" > /dev/null 2>&1
-    done < "$VARFILE"
-    rm -f "$VARFILE" 2> /dev/null
-    succ_msg
-    return 0
-}
-
-case "$1" in
-start)
-    start_network
-    ;;
-stop)
-    stop_network
-    ;;
-restart|reload)
-    stop_network && start_network
-    ;;
-force-reload)
-    stop_network
-    start_network
-    ;;
-force-stop)
-    force_stop_network
-    ;;
-status)
-    if running; then
-        echo "VirtualBox host networking is loaded."
-    else
-        echo "VirtualBox host networking is not loaded."
-    fi
-    ;;
-*)
-    echo "Usage: `basename $0` {start|stop|force-stop|restart|force-reload|status}"
-    exit 1
-esac
-
-exit 0