Index: trunk/src/VBox/Devices/Network/slirp/debug.c
===================================================================
--- trunk/src/VBox/Devices/Network/slirp/debug.c	(revision 14471)
+++ trunk/src/VBox/Devices/Network/slirp/debug.c	(revision 14476)
@@ -30,61 +30,4 @@
 #endif
 
-#if 0
-/*
- * Statistic routines
- *
- * These will print statistics to the screen, the debug file (dfd), or
- * a buffer, depending on "type", so that the stats can be sent over
- * the link as well.
- */
-
-void
-ttystats(ttyp)
-        struct ttys *ttyp;
-{
-        struct slirp_ifstats *is = &ttyp->ifstats;
-        char buff[512];
-
-        lprint(" \r\n");
-
-        if (if_comp & IF_COMPRESS)
-           strcpy(buff, "on");
-        else if (if_comp & IF_NOCOMPRESS)
-           strcpy(buff, "off");
-        else
-           strcpy(buff, "off (for now)");
-        lprint("Unit %d:\r\n", ttyp->unit);
-        lprint("  using %s encapsulation (VJ compression is %s)\r\n", (
-#ifdef USE_PPP
-               ttyp->proto==PROTO_PPP?"PPP":
-#endif
-               "SLIP"), buff);
-        lprint("  %d baudrate\r\n", ttyp->baud);
-        lprint("  interface is %s\r\n", ttyp->up?"up":"down");
-        lprint("  using fd %d, guardian pid is %d\r\n", ttyp->fd, ttyp->pid);
-#ifndef FULL_BOLT
-        lprint("  towrite is %d bytes\r\n", ttyp->towrite);
-#endif
-        if (ttyp->zeros)
-           lprint("  %d zeros have been typed\r\n", ttyp->zeros);
-        else if (ttyp->ones)
-           lprint("  %d ones have been typed\r\n", ttyp->ones);
-        lprint("Interface stats:\r\n");
-        lprint("  %6d output packets sent (%d bytes)\r\n", is->out_pkts, is->out_bytes);
-        lprint("  %6d output packets dropped (%d bytes)\r\n", is->out_errpkts, is->out_errbytes);
-        lprint("  %6d input packets received (%d bytes)\r\n", is->in_pkts, is->in_bytes);
-        lprint("  %6d input packets dropped (%d bytes)\r\n", is->in_errpkts, is->in_errbytes);
-        lprint("  %6d bad input packets\r\n", is->in_mbad);
-}
-
-void
-allttystats()
-{
-        struct ttys *ttyp;
-
-        for (ttyp = ttys; ttyp; ttyp = ttyp->next)
-           ttystats(ttyp);
-}
-#endif
 
 void
@@ -112,22 +55,4 @@
 }
 
-#if 0
-void
-vjstats()
-{
-        lprint(" \r\n");
-
-        lprint("VJ compression stats:\r\n");
-
-        lprint("  %6d outbound packets (%d compressed)\r\n",
-               comp_s.sls_packets, comp_s.sls_compressed);
-        lprint("  %6d searches for connection stats (%d misses)\r\n",
-               comp_s.sls_searches, comp_s.sls_misses);
-        lprint("  %6d inbound uncompressed packets\r\n", comp_s.sls_uncompressedin);
-        lprint("  %6d inbound compressed packets\r\n", comp_s.sls_compressedin);
-        lprint("  %6d inbound unknown type packets\r\n", comp_s.sls_errorin);
-        lprint("  %6d inbound packets tossed due to error\r\n", comp_s.sls_tossed);
-}
-#endif
 
 void
Index: trunk/src/VBox/Devices/Network/slirp/debug.h
===================================================================
--- trunk/src/VBox/Devices/Network/slirp/debug.h	(revision 14471)
+++ trunk/src/VBox/Devices/Network/slirp/debug.h	(revision 14476)
@@ -63,6 +63,4 @@
 
 void debug_init _P((char *, int));
-/*void ttystats _P((struct ttys *)); */
-void allttystats _P((void));
 void ipstats _P((PNATState));
 void tcpstats _P((PNATState));
Index: trunk/src/VBox/Devices/Network/slirp/if.h
===================================================================
--- trunk/src/VBox/Devices/Network/slirp/if.h	(revision 14471)
+++ trunk/src/VBox/Devices/Network/slirp/if.h	(revision 14476)
@@ -30,21 +30,3 @@
 #define ifs_init(ifm) ((ifm)->ifs_next = (ifm)->ifs_prev = (ifm))
 
-/* Interface statistics */
-struct slirp_ifstats {
-        u_int out_pkts;         /* Output packets */
-        u_int out_bytes;                /* Output bytes */
-        u_int out_errpkts;      /* Output Error Packets */
-        u_int out_errbytes;     /* Output Error Bytes */
-        u_int in_pkts;          /* Input packets */
-        u_int in_bytes;         /* Input bytes */
-        u_int in_errpkts;               /* Input Error Packets */
-        u_int in_errbytes;      /* Input Error Bytes */
-        
-        u_int bytes_saved;      /* Number of bytes that compression "saved" */
-                                /* ie: number of bytes that didn't need to be sent over the link
-                                 * because of compression */
-        
-        u_int in_mbad;          /* Bad incoming packets */
-};
-
 #endif
Index: trunk/src/VBox/Devices/Network/slirp/slirp.c
===================================================================
--- trunk/src/VBox/Devices/Network/slirp/slirp.c	(revision 14471)
+++ trunk/src/VBox/Devices/Network/slirp/slirp.c	(revision 14476)
@@ -379,7 +379,5 @@
 {
     struct socket *so, *so_next;
-    struct timeval timeout;
     int nfds;
-    int tmp_time;
 #if defined(VBOX_WITH_SIMPLIFIED_SLIRP_SYNC) && defined(RT_OS_WINDOWS)
     int rc;
@@ -571,37 +569,4 @@
         }
 
-        /*
-         * Setup timeout to use minimum CPU usage, especially when idle
-         */
-
-        /*
-         * First, see the timeout needed by *timo
-         */
-        timeout.tv_sec = 0;
-        timeout.tv_usec = -1;
-        /*
-         * If a slowtimo is needed, set timeout to 500ms from the last
-         * slow timeout. If a fast timeout is needed, set timeout within
-         * 200ms of when it was requested.
-         */
-        if (do_slowtimo) {
-                /* XXX + 10000 because some select()'s aren't that accurate */
-                timeout.tv_usec = ((500 - (curtime - last_slowtimo)) * 1000) + 10000;
-                if (timeout.tv_usec < 0)
-                   timeout.tv_usec = 0;
-                else if (timeout.tv_usec > 510000)
-                   timeout.tv_usec = 510000;
-
-                /* Can only fasttimo if we also slowtimo */
-                if (time_fasttimo) {
-                        tmp_time = (200 - (curtime - time_fasttimo)) * 1000;
-                        if (tmp_time < 0)
-                           tmp_time = 0;
-
-                        /* Choose the smallest of the 2 */
-                        if (tmp_time < timeout.tv_usec)
-                           timeout.tv_usec = (u_int)tmp_time;
-                }
-        }
 #if !defined(VBOX_WITH_SIMPLIFIED_SLIRP_SYNC) || !defined(RT_OS_WINDOWS)
         *pnfds = nfds;
Index: trunk/src/VBox/Devices/Network/slirp/tcp_input.c
===================================================================
--- trunk/src/VBox/Devices/Network/slirp/tcp_input.c	(revision 14471)
+++ trunk/src/VBox/Devices/Network/slirp/tcp_input.c	(revision 14476)
@@ -421,5 +421,4 @@
         int iss = 0;
         u_long tiwin;
-        int ret;
 /*      int ts_present = 0; */
         int mbuf_freed = 0;